#!/usr/bin/perl 
#
# Script:           system_graphs.pl
# Original Author:  freddy <freddy@linuxtribe.fr>
# Modified by:      Michael Stauber <mstauber@solarspeed.net>

$DEBUG=0;

# Location of the vzlist-dump:
$vzlistdump = '/tmp/vserver-tgraphlist';

if (defined($ARGV[2])) {
    if ($ARGV[0] = "graph") {
        $vpsgiven = $ARGV[2];
    }
}

system("/usr/sbin/vzlist -a -o ctid,ip,hostname,status| sed 's/^[ \t]*//;s/[ \t]*\$//' > $vzlistdump");

open (F, $vzlistdump) || die "Could not open $vzlistdump: $!";
$a = 0;
while ($line = <F>) {
    chomp($line);
    next if $line =~ /^\s*$/;               # skip blank lines
    if ($line =~ /^CTID(.*)$/) {
        $matrix_name = 'CTID';
    }
    else {
        (@row) = split (/\s+/, $line);
        push (@{$matrix_name}, \@row);
    }

    if ($CTID[$a][0]) {            
        $currentvpsid = $CTID[$a][0];
        &feedthemonster;
    }
    $a++;
}
close(F);
system("/bin/rm -f $vzlistdump");

#
### Subs
#

sub feedthemonster {
    if ($CTID[$a][3] eq "running") {
        $veid = $CTID[$a][0];
        $hostname = $CTID[$a][2];
        if ($DEBUG) {
            print "VPSID: $veid - HN: $hostname\n";
        }
        if ((defined($ARGV[2])) && ($vpsgiven == $veid))  {
            &bingo;
        }
        unless (defined($ARGV[2])) {
            &bingo;
        }
    }
}

exit;

sub bingo {

    $rrdbin='/usr/bin/rrdtool';
    $web_path_basic="/usr/sausalito/ui/web/base/traffic/vpsimages";
    $web_path=$web_path_basic . "/" . $veid;
    $rrddb="/usr/sausalito/ui/web/base/traffic/vpsimages/$veid/$veid.rrd";
    $interfaces='lo,venet0';

    if ( ! -d "$web_path_basic") {
        system("/bin/mkdir -p $web_path_basic");
        system("/bin/chmod 755 $web_path_basic");
    }

    if ( ! -d "$web_path" ) {
        system("/bin/mkdir -p $web_path");
        system("/bin/chmod 755 $web_path");
    }

    # Bellow rrd database definition. You may keep this.

    $update_interval=300;
    $unknown_interval=$update_interval*5;
    $daily_rra_row=86400/$update_interval;
    $weekly_rra_row=86400/$update_interval;
    $monthly_rra_row=86400/$update_interval;
    $yearly_rra_row=86400/$update_interval;

    $excluded_ds='vmguarpages|dummy';

    %units = (
        'kmemsize' => 'bytes',
        'failkmemsize' => 'failure',
        'lockedpages' => '4KB pages',
        'faillockedpages' => 'failure',
        'privvmpages' => '4KB pages',
        'failprivvmpages' => 'failure',
        'shmpages' => '4KB pages',
        'failshmpages' => 'failure',
        'dummy' => 'none',
        'numproc' => 'processes',
        'failnumproc' => 'failure',
        'physpages' => '4KB pages',
        'failphyspages' => 'failure',
        'vmguarpages' => '4KB pages',
        'failvmguarpages' => 'failure',
        'oomguarpages' => '4KB pages',
        'failoomguarpages' => 'failure',
        'numtcpsock' => 'TCP sockets',
        'failnumtcpsock' => 'failure',
        'numflock' => 'file locks',
        'failnumflock' => 'failure',
        'numpty' => 'pty',
        'failnumpty' => 'failure',
        'numsiginfo' => 'siginfo struct',
        'failnumsiginfo' => 'failure',
        'tcpsndbuf' => 'bytes',
        'failtcpsndbuf' => 'failure',
        'tcprcvbuf' => 'bytes',
        'failtcprcvbuf' => 'failure',
        'othersockbuf' => 'bytes',
        'failothersockbuf' => 'failure',
        'dgramrcvbuf' => 'bytes',
        'faildgramrcvbuf' => 'failure',
        'numothersock' => 'non TCP sockets',
        'failnumothersock' => 'failure',
        'dcachesize' => 'bytes',
        'faildcachesize' => 'failure',
        'numfile' => 'open files',
        'failnumfile' => 'failure',
        'numiptent' => 'netfilter entries',
        'failnumiptent' => 'failure'
    );

    %details = (
        'kmemsize' => 'Size of unswappable memory, allocated by the operating system kernel',
        'failkmemsize' => 'Size of unswappable memory, allocated by the operating system kernel',
        'lockedpages' => 'Process pages not allowed to be swapped out (pages locked by mlock(2))',
        'faillockedpages' => 'Process pages not allowed to be swapped out (pages locked by mlock(2))',
        'privvmpages' => 'Memory allocation limit',
        'failprivvmpages' => 'Memory allocation limit',
        'shmpages' => 'Total size of shared memory',
        'failshmpages' => 'Total size of shared memory',
        'dummy' => 'none',
        'numproc' => 'Number of processes and kernel-level threads allowed for VE',
        'failnumproc' => 'Number of processes and kernel-level threads allowed for VE',
        'physpages' => 'Total number of RAM pages used by processes in this VE',
        'failphyspages' => 'Total number of RAM pages used by processes in this VE',
        'vmguarpages' => 'Memory allocation guarantee',
        'failvmguarpages' => 'Memory allocation guarantee',
        'oomguarpages' => 'The guaranteed amount of memory for the case the memory is over-booked',
        'failoomguarpages' => 'The guaranteed amount of memory for the case the memory is over-booked',
        'numtcpsock' => 'Number of TCP sockets',
        'failnumtcpsock' => 'Number of TCP sockets',
        'numflock' => 'Number of file locks',
        'failnumflock' => 'Number of file locks',
        'numpty' => 'Number of pseudo-terminals',
        'failnumpty' => 'Number of pseudo-terminals',
        'numsiginfo' => 'Number of siginfo structures',
        'failnumsiginfo' => 'Number of siginfo structures',
        'tcpsndbuf' => 'Total size of buffers used to send data over TCP network connections',
        'failtcpsndbuf' => 'Total size of buffers used to send data over TCP network connections',
        'tcprcvbuf' => 'Total size of buffers used to store data coming from TCP network connections',
        'failtcprcvbuf' => 'Total size of buffers used to store data coming from TCP network connections',
        'othersockbuf' => 'Total size of buffers used by local connections and datagram protocols',
        'failothersockbuf' => 'Total size of buffers used by local connections and datagram protocols',
        'dgramrcvbuf' => 'Total size of buffers used to store incoming datagram packets',
        'faildgramrcvbuf' => 'Total size of buffers used to store incoming datagram packets',
        'numothersock' => 'Number of non-TCP sockets (local sockets, UDP and other tpyes of sockets)',
        'failnumothersock' => 'Number of non-TCP sockets (local sockets, UDP and other tpyes of sockets)',
        'dcachesize' => 'Total size of dentry and inode structures locked in memory',
        'faildcachesize' => 'Total size of dentry and inode structures locked in memory',
        'numfile' => 'Number of open files',
        'failnumfile' => 'Number of open files',
        'numiptent' => 'Number of NETFILTER (IP packet filtering) entries',
        'failnumiptent' => 'Number of NETFILTER (IP packet filtering) entries'
    );

    %sec = (
    'daily' => 86400,
    'weekly' => 604800,
    'monthly' => 2678400,
    'yearly' => 31536000
    );

    $mode;
    $graph_mode;

    if (defined($ARGV[0])) {
        if ($ARGV[0] eq "graph") {
            $mode="graph";
            unless(defined($ARGV[1])) {
                $graph_mode='daily';
            }
            elsif ($ARGV[1] =~ /^(daily|weekly|monthly|yearly)$/) {
                $graph_mode=$1;
            }
            else {
                &usage;
            }
        }
        elsif ($ARGV[0] eq "update") {
            $mode="update";
        }
        else {
            &usage;
        }
    } 
    else {
        &usage;
    }

    $t;
    $t=time()-$update_interval unless(-f $rrddb);
    $t=time() if (-f $rrddb);

    @data=`/usr/sbin/vzctl exec $veid cat /proc/user_beancounters`;
    chomp @data;

    %usage;
    ($ds,$value)=(undef,undef);

    foreach (@data) {
        if (/(\w+)[\t\s]+(\d+)[\t\s]+(\d+)[\t\s]+(\d+)[\t\s]+(\d+)[\t\s]+(\d+)/) {
            $usage{$1}{'held'}=$2;
            $usage{$1}{'maxheld'}=$3;
            $usage{$1}{'barrier'}=$4;
            $usage{$1}{'limit'}=$5;
            $usage{$1}{'failcnt'}=$6;
            unless($1 eq "dummy") {
                unless(defined($ds)) {
                    $ds="$1:fail$1";
                    $value="$2:$6";
                }
                else {
                    $ds.=":$1:fail$1";
                    $value.=":$2:$6";
                }
            }
        }
    }

    @ordered_ds;
    @dum;

    push @ordered_ds,"#SECTION Networking";

    foreach $i (split(/,/,$interfaces)) {
        push @ordered_ds,$i;
        @dum=`/sbin/ifconfig $i`;
        foreach (@dum) {
            if (/RX bytes:(\d+) \(.+TX bytes:(\d+) \(/) {
                $details{"$i"}="network usage on interface $i";
                $units{"$i"}="bytes";
                $ds.=":in$i:out$i";
                $value.=":$1:$2";
            }
        }
    }

    @dum = (
        'numiptent', # 'Number of NETFILTER (IP packet filtering) entries'
        'failnumiptent', # 'Number of NETFILTER (IP packet filtering) entries'
        'numtcpsock', # 'Number of TCP sockets',
        'failnumtcpsock', # 'Number of TCP sockets',
        'numothersock', # 'Number of non-TCP sockets (local sockets, UDP and other tpyes of sockets)',
        'failnumothersock', # 'Number of non-TCP sockets (local sockets, UDP and other tpyes of sockets)',
        'tcpsndbuf', # 'Total size of buffers used to send data over TCP network connections',
        'failtcpsndbuf', # 'Total size of buffers used to send data over TCP network connections',
        'tcprcvbuf', # 'Total size of buffers used to store data coming from TCP network connections',
        'failtcprcvbuf', # 'Total size of buffers used to store data coming from TCP network connections',
        'othersockbuf', # 'Total size of buffers used by local connections and datagram protocols',
        'failothersockbuf', # 'Total size of buffers used by local connections and datagram protocols',
        'dgramrcvbuf', # 'Total size of buffers used to store incoming datagram packets',
        'faildgramrcvbuf', # 'Total size of buffers used to store incoming datagram packets',
        '#SECTION System',
        'numpty', # 'Number of pseudo-terminals',
        'failnumpty', # 'Number of pseudo-terminals',
        'numproc', # 'Number of processes and kernel-level threads allowed for VE',
        'failnumproc', # 'Number of processes and kernel-level threads allowed for VE',
        'numfile', # 'Number of open files',
        'failnumfile', # 'Number of open files',
        'numflock', # 'Number of file locks',
        'failnumflock', # 'Number of file locks',
        'dcachesize', # 'Total size of dentry and inode structures locked in memory',
        'faildcachesize', # 'Total size of dentry and inode structures locked in memory',
        'numsiginfo', # 'Number of siginfo structures',
        'failnumsiginfo', # 'Number of siginfo structures',
        '#SECTION Memory',
        'kmemsize', # 'Size of unswappable memory, allocated by the operating system kernel',
        'failkmemsize', # 'Size of unswappable memory, allocated by the operating system kernel',
        'physpages', # 'Total number of RAM pages used by processes in this VE',
        'failphyspages', # 'Total number of RAM pages used by processes in this VE',
        'oomguarpages', # 'The guaranteed amount of memory for the case the memory is over-booked',
        'failoomguarpages', # 'The guaranteed amount of memory for the case the memory is over-booked',
        'shmpages', # 'Total size of shared memory',
        'failshmpages', # 'Total size of shared memory',
        'vmguarpages', # 'Memory allocation guarantee',
        'failvmguarpages', # 'Memory allocation guarantee',
        'lockedpages', # 'Process pages not allowed to be swapped out (pages locked by mlock(2))',
        'faillockedpages', # 'Process pages not allowed to be swapped out (pages locked by mlock(2))',
        'privvmpages', # 'Memory allocation limit',
        'failprivvmpages', # 'Memory allocation limit',
        'dummy' # 'none'
    );
    push @ordered_ds,@dum;

    if ($mode eq "update") {
            @create_args = (
            "$rrddb",
            "--start $t",
            "--step $update_interval",
            "DS:dcachesize:GAUGE:$unknown_interval:0:U",
            "DS:faildcachesize:DERIVE:$unknown_interval:0:U",
            "DS:dgramrcvbuf:GAUGE:$unknown_interval:0:U",
            "DS:faildgramrcvbuf:DERIVE:$unknown_interval:0:U",
            "DS:kmemsize:GAUGE:$unknown_interval:0:U",
            "DS:failkmemsize:DERIVE:$unknown_interval:0:U",
            "DS:lockedpages:GAUGE:$unknown_interval:0:U",
            "DS:faillockedpages:DERIVE:$unknown_interval:0:U",
            "DS:numfile:GAUGE:$unknown_interval:0:U",
            "DS:failnumfile:DERIVE:$unknown_interval:0:U",
            "DS:numflock:GAUGE:$unknown_interval:0:U",
            "DS:failnumflock:DERIVE:$unknown_interval:0:U",
            "DS:numiptent:GAUGE:$unknown_interval:0:U",
            "DS:failnumiptent:DERIVE:$unknown_interval:0:U",
            "DS:numothersock:GAUGE:$unknown_interval:0:U",
            "DS:failnumothersock:DERIVE:$unknown_interval:0:U",
            "DS:numproc:GAUGE:$unknown_interval:0:U",
            "DS:failnumproc:DERIVE:$unknown_interval:0:U",
            "DS:numpty:GAUGE:$unknown_interval:0:U",
            "DS:failnumpty:DERIVE:$unknown_interval:0:U",
            "DS:numsiginfo:GAUGE:$unknown_interval:0:U",
            "DS:failnumsiginfo:DERIVE:$unknown_interval:0:U",
            "DS:numtcpsock:GAUGE:$unknown_interval:0:U",
            "DS:failnumtcpsock:DERIVE:$unknown_interval:0:U",
            "DS:oomguarpages:GAUGE:$unknown_interval:0:U",
            "DS:failoomguarpages:DERIVE:$unknown_interval:0:U",
            "DS:othersockbuf:GAUGE:$unknown_interval:0:U",
            "DS:failothersockbuf:DERIVE:$unknown_interval:0:U",
            "DS:physpages:GAUGE:$unknown_interval:0:U",
            "DS:failphyspages:DERIVE:$unknown_interval:0:U",
            "DS:privvmpages:GAUGE:$unknown_interval:0:U",
            "DS:failprivvmpages:DERIVE:$unknown_interval:0:U",
            "DS:shmpages:GAUGE:$unknown_interval:0:U",
            "DS:failshmpages:DERIVE:$unknown_interval:0:U",
            "DS:tcprcvbuf:GAUGE:$unknown_interval:0:U",
            "DS:failtcprcvbuf:DERIVE:$unknown_interval:0:U",
            "DS:tcpsndbuf:GAUGE:$unknown_interval:0:U",
            "DS:failtcpsndbuf:DERIVE:$unknown_interval:0:U",
            "DS:vmguarpages:GAUGE:$unknown_interval:0:U",
            "DS:failvmguarpages:DERIVE:$unknown_interval:0:U"
        );

        foreach (split(/,/,$interfaces)) {
            push @create_args, "DS:in$_:DERIVE:$unknown_interval:0:U";
            push @create_args, "DS:out$_:DERIVE:$unknown_interval:0:U";
        }

        @dum = (
            "RRA:MIN:0.5:1:$daily_rra_row",
            "RRA:AVERAGE:0.5:1:$daily_rra_row",
            "RRA:MAX:0.5:1:$daily_rra_row",
            "RRA:MIN:0.5:7:$weekly_rra_row",
            "RRA:AVERAGE:0.5:7:$weekly_rra_row",
            "RRA:MAX:0.5:7:$weekly_rra_row",
            "RRA:MIN:0.5:31:$monthly_rra_row",
            "RRA:AVERAGE:0.5:31:$monthly_rra_row",
            "RRA:MAX:0.5:31:$monthly_rra_row",
            "RRA:MIN:0.5:365:$yearly_rra_row",
            "RRA:AVERAGE:0.5:365:$yearly_rra_row",
            "RRA:MAX:0.5:365:$yearly_rra_row"
        );
        push @create_args, @dum;

        create_rrd(@create_args) unless(-f $rrddb);
        update_rrd("$rrddb","--template $ds","$t:$value");

    }
    elsif ($mode eq "graph") {

        @graph_args;
        foreach $ds (@ordered_ds) {
            if ($ds =~ /^#SECTION (.+)$/) {
                next;
            }
            next if ($ds =~ /$excluded_ds/);
            if ($details{$ds} =~ /network usage on interface/) {
                @graph_args=(
                    "$web_path/" . $ds ."_$graph_mode.png","--start ".($t-$sec{$graph_mode}),"--end $t",
                    "--title 'VPS $veid:\n $details{$ds}'", "--vertical-label '$units{$ds}'",
                    "--imgformat PNG", 
                    "--lazy",
                    "--font DEFAULT:8:",
                    "--width 640", "--height 230",
                    "DEF:minin$ds=$rrddb:in$ds:MIN",
                    "DEF:avgin$ds=$rrddb:in$ds:AVERAGE",
                    "DEF:maxin$ds=$rrddb:in$ds:MAX",
                    "DEF:minout$ds=$rrddb:out$ds:MIN",
                    "DEF:avgout$ds=$rrddb:out$ds:AVERAGE",
                    "DEF:maxout$ds=$rrddb:out$ds:MAX"
                );
            }
            elsif ($units{$ds} eq '4KB pages') {
                $units{$ds}='bytes';
                $usage{$ds}{'barrier'}*=4096;
                @graph_args=(
                    "$web_path/" . $ds ."_$graph_mode.png","--start ".($t-$sec{$graph_mode}),"--end $t",
                    "--title 'VPS $veid: $details{$ds} ($ds)'", "--vertical-label '$units{$ds}'",
                    "--imgformat PNG", 
                    "--lazy",
                    "--font DEFAULT:8:",
                    "--width 640", "--height 230", 
                    #"--upper-limit $usage{$ds}{'barrier'}",
                    "DEF:_min$ds=$rrddb:$ds:MIN",
                    "DEF:_avg$ds=$rrddb:$ds:AVERAGE",
                    "DEF:_max$ds=$rrddb:$ds:MAX",
                    "CDEF:min$ds=_min$ds,4096,*",
                    "CDEF:avg$ds=_avg$ds,4096,*",
                    "CDEF:max$ds=_max$ds,4096,*"
                    
                );
            }
            elsif ($units{$ds} eq 'failure') {
                @graph_args=(
                    "$web_path/" .$ds."_$graph_mode.png","--start ".($t-$sec{$graph_mode}),"--end $t",
                    "--title 'VPS $veid: $details{$ds} ($ds)'", "--vertical-label '$units{$ds}'",
                    "--imgformat PNG", 
                    "--lazy",
                    "--font DEFAULT:8:",
                    "--width 640", "--height 230",
                    "DEF:min$ds=$rrddb:$ds:MIN",
                    "DEF:avg$ds=$rrddb:$ds:AVERAGE",
                    "DEF:max$ds=$rrddb:$ds:MAX"
                );
            }
            else {
                @graph_args=(
                    "$web_path/" . $ds."_$graph_mode.png","--start ".($t-$sec{$graph_mode}),"--end $t",
                    "--title 'VPS $veid: $details{$ds} ($ds)'", "--vertical-label '$units{$ds}'",
                    "--imgformat PNG", 
                    "--lazy",
                    "--font DEFAULT:8:",
                    "--width 640", "--height 230", 
                    #"--upper-limit $usage{$ds}{'barrier'}",
                    "DEF:min$ds=$rrddb:$ds:MIN",
                    "DEF:avg$ds=$rrddb:$ds:AVERAGE",
                    "DEF:max$ds=$rrddb:$ds:MAX"
                );
            }
            if ($units{$ds} eq 'bytes') {
                push @graph_args, "--base 1024";
            }
            if ($details{$ds} =~ /network usage on interface/) {
                    @dum=(
                                    "AREA:avgin$ds#d6f4b6:'bytes in'",
                                    "GPRINT:minin$ds:MIN:'(min %.2lf%s'",
                                    "GPRINT:avgin$ds:AVERAGE:'avg %.2lf%s'",
                                    "GPRINT:maxin$ds:MAX:'max %.2lf%s)'",
                                    "LINE1:avgout$ds#a3a3e5:'bytes out'",
                                    #"LINE:avgout$ds#0033CC:'bytes out'",
                                    "GPRINT:minout$ds:MIN:'(avg %.2lf%s'",
                                    "GPRINT:avgout$ds:AVERAGE:'avg %.2lf%s'",
                                    "GPRINT:maxout$ds:MAX:'max %.2lf%s)'"
                            );
            }
            elsif ($units{$ds} eq 'failure') {
                @dum=(
                    "AREA:max$ds#ff0000:'failure'",
                    "GPRINT:min$ds:MIN:'(min %.2lf%s'",
                    "GPRINT:avg$ds:AVERAGE:'avg %.2lf%s'",
                    "GPRINT:max$ds:MAX:'max %.2lf%s)'"
                );
            }
            else {
                @dum=(
                    #"AREA:min$ds#d6f4b6:'min'",
                    "AREA:min$ds#56f45f:'min'",
                    "GPRINT:min$ds:MIN:'%.2lf%s'",
                    #"LINE1:avg$ds#f4deb6:'avg'", 
                    "LINE1:avg$ds#0033CC:'avg'", 
                    "GPRINT:avg$ds:AVERAGE:'%.2lf%s'",
                    #"LINE1:max$ds#f4b6ba:'max'",
                    "LINE1:max$ds#f43300:'max'",
                    "GPRINT:max$ds:MAX:'%.2lf%s'"
                );
            }
            push @graph_args, @dum;
            graph_rrd(@graph_args);
            splice @graph_args;
        }
    }
    else {
        &usage;
    }

} # end sub bingo

sub graph_rrd {
    print "$rrdbin graph @_\n" if ($DEBUG);
    system("$rrdbin graph @_ > /dev/null");
}

sub update_rrd {
    print "$rrdbin update @_\n" if ($DEBUG);
    system("$rrdbin update @_");
}

sub create_rrd {
    print "$rrdbin create @_\n" if ($DEBUG);
    system("$rrdbin create @_");
    $t+=$update_interval;
}

sub usage {
    print "Usage: $0 update\n";
    print "       $0 graph [daily|weekly|monthly|yearly]\n";
    print "                (daily graph option is assumed if no one is given)\n";
    exit 1;
}
